%include "..\macros.inc"
%include "mem32.inc"
[segment text]
[bits 32]
%DEFINE WIN32

extern	_GetProcessHeap@0

global _main

global	_main_initialize,_main_destroy,_main_step,_main_render
global	_matrixaddr
global	matrix
extern	_animplay_initialize,_animplay_destroy,_animplay_step,_animplay_render
extern	_falling_initialize,_falling_destroy,_falling_step,_falling_render

_main_initialize:
		pushad

		invoke _GetProcessHeap@0
		mov dword [hHeap],eax

;		call _animplay_initialize
		call _falling_initialize

		popad
		ret

_main_destroy:
		pushad

;		call _animplay_destroy
		call _falling_destroy

		popad
		ret

_main_step:
		pushad

;		call _animplay_step
		call _falling_step

		popad
		ret

_main_render:
		pushad

;		call _animplay_render
		call _falling_render

		popad
		ret

_matrixaddr:

		mov eax,[matrix]

		ret

[segment .data]
matrix		dd	_matrix
_matrix 	times	24*24 db(0)
