[segment code32]
[bits 32]

%include	"..\pmode.inc"
%include 	"screen.inc"
%include	"timing.inc"
%include	"memory.inc"

extern	_output_initialize,_output_destroy,_output_render
extern	_animplay_initialize,_animplay_destroy,_animplay_step,_animplay_render
extern	_falling_initialize,_falling_destroy,_falling_step,_falling_render

global	_main

_main:
	sti


	call _timer_initialize

	call _initmcga
	call _initscreen
	call _output_initialize

	call _clearscreen

;	call _animplay_initialize
	call _falling_initialize

.ml:	cmp dword [counter],0
	jz .ml
	mov ecx,[counter]
	xor eax,eax
	mov [counter],eax
.ml2:	push ecx
;	call _animplay_step
	call _falling_step
	pop ecx
	loop .ml2
;	call _animplay_render
	call _falling_render
	call _output_render
	call _putscreen

	push es
	mov word [v86r_ax],0x0100
	mov ax,16h
	int 33h
	pop es
	jnz .mlend

	jmp .ml
.mlend:

;	call _animplay_destroy
	call _falling_destroy

	call _timer_destroy

	push es
	mov word [v86r_ax],0
	mov ax,16h
	int 33h
	pop es


	call _output_destroy
	call _restoretext

	jmp _exit